package com.diagbot.config.RateLimiter;

import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;
import org.springframework.data.redis.core.ReactiveRedisTemplate;
import org.springframework.data.redis.core.script.RedisScript;
import org.springframework.validation.Validator;

import java.util.List;

/**
 * @Description:
 * @author: gaodm
 * @time: 2019/12/26 15:08
 */
@Configuration
public class SysKeyResolverConfigurer {

    @Bean
    public SysKeyResolver sysKeyResolver() {
        return new SysKeyResolver();
    }

    @Bean
    @Primary
    //使用自己定义的限流类
    public SystemRedisRateLimiter systemRedisRateLimiter(
            ReactiveRedisTemplate<String, String> redisTemplate,
            @Qualifier(SystemRedisRateLimiter.REDIS_SCRIPT_NAME) RedisScript<List<Long>> script,
            Validator validator){
        return new SystemRedisRateLimiter(redisTemplate , script , validator);
    }
}
